// swad_QR.h: QR codes

#ifndef _SWAD_QR
#define _SWAD_QR
/*
    SWAD (Shared Workspace At a Distance in Spanish),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.

    This file is part of SWAD core.
    Copyright (C) 1999-2015 Antonio Caas Vargas

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*****************************************************************************/
/********************************* Headers ***********************************/
/*****************************************************************************/

/*****************************************************************************/
/***************************** Public constants ******************************/
/*****************************************************************************/

#define QR_NUM_QR_TYPES 3

/*****************************************************************************/
/******************************* Public types ********************************/
/*****************************************************************************/

typedef enum
  {
   QR_ID       = 0,
   QR_NICKNAME = 1,
   QR_EMAIL    = 2,
  } QR_QRType_t;

/*****************************************************************************/
/***************************** Public prototypes *****************************/
/*****************************************************************************/

void QR_PutLinkToPrintQRCode (QR_QRType_t QRType,struct UsrData *UsrDat,bool PrintText);
void QR_PrintQRCode (void);

void QR_LinkToCountry (unsigned Size);
void QR_LinkToInstitution (unsigned Size);
void QR_LinkToCentre (unsigned Size);
void QR_LinkToDegree (unsigned Size);
void QR_LinkToCourse (unsigned Size);
void QR_ExamAnnnouncement (void);

#endif
